-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
local logTag = 'mfmConfig' -- please change to sth more meaningful
local curMission = "Default"
-- executed when a level was loaded

extensions.loadModule("MFMGE_IO")
extensions.loadModule("MFMGE_BINDINGS")

local function onClientStartMission(mission)
    --os.execute("mkdir game:mods/config/MoreFeaturesMod/VLua")
    --os.execute("mkdir game:mods/config/MoreFeaturesMod/GELua")

    serializeJsonToFile("game:mods/config/MoreFeaturesMod/LevelData/MapTemp.json", { loaded = false }, true)

    serializeJsonToFile("game:mods/config/MoreFeaturesMod/tmp/Version.json", { version = beamng_version }, true)
    serializeJsonToFile("game:mods/config/MoreFeaturesMod/tmp/CurrentMap.json", { mission = mission:gsub("%/", "_"):gsub("%.mis", "") }, true)
    curMission = mission
    print("More Features Mod GameEngine Loaded.")
    TorqueScript.eval("LuaReload();")
    --print("Ran Save Configuration For More Features Mod")

end

-- executed when a level was unloaded
local function onClientEndMission(mission)
end

-- executed on the first update where the engine is up and running
local function onFirstUpdate()
    serializeJsonToFile("game:mods/config/MoreFeaturesMod/tmp/Version.json", { version = beamng_version }, true)

end

-- executed every frame, also when not rendering 3d in the menu
local function onUpdate()
    if(FS:fileExists("game:mods/config/MoreFeaturesMod/LevelData/vPosition.json")) then
        local fileLoad = readJsonFile("game:mods/config/MoreFeaturesMod/LevelData/vPosition.json")
        --print(curMission)

        local pos = {
            x = fileLoad.pos.x,
            y = fileLoad.pos.y,
            z = fileLoad.pos.z,
        }
        local rot = {
            x = fileLoad.rot.x,
            y = fileLoad.rot.y,
            z = fileLoad.rot.z,
            w = 1,
        }
        local dir = {
            heading = fileLoad.dir.heading,
        }

        rot = quatFromDir(vec3(math.sin(-dir.heading), math.cos(-dir.heading), 0), vec3(0,0,1))

        serializeJsonToFile("game:mods/config/MoreFeaturesMod/LevelData/".. curMission:gsub("%/", "_"):gsub("%.mis", "") ..".json", { pos = pos, rot = rot, dir = dir }, true)
        os.remove("game:mods/config/MoreFeaturesMod/LevelData/vPosition.json")
    end
end

-- executed before every 3d render of a frame
local function onPreRender(dt)
    --log('D', logTag, 'onPreRender: ' .. dt) -- this is heavy on the log, use with care
end
 
-- triggered when the game engine detects a file change. Useful to detect if the state should be reloaded when using external data (i.e. JSon)
local function onFileChanged(filename, _type)

end

-- called on physics engine state changed: spawning vehicles, deleting vehicles, changing time, etc
local function onPhysicsEngineEvent(...)
    --Save License Plate For When You Restart The Game

end


-- public interface
M.onClientStartMission = onClientStartMission
M.onClientEndMission = onClientEndMission
M.onFirstUpdate = onFirstUpdate
M.onUpdate = onUpdate
--M.onPreRender = onPreRender
M.onFileChanged = onFileChanged
M.onPhysicsEngineEvent = onPhysicsEngineEvent
M.doSomething = doSomething

return M
