local M = {}
--[[
    Hello, this is the source code for the More Features Mod, you may look and modify stuff as you wish, 
    but you are not allowed to re-publish the mod or any code that you used in this without my permission.

    StinchinStein
]]--
local drivetrain = require("drivetrain")
local electrics = require("electrics")
local engine = require("engine")

M.batteryWarnTxt = false --Inc. of 10
M.batteryUsage = 0
M.batteryPercentage = 0
M.batteryChargeRate = 0
M.batteryCriticalTimer = 0
M.batteryDead = true
local function init()
    M.batteryPercentage = 100
    M.batteryUsage = 0
    M.batteryChargeRate = 0
    M.batteryStatusMsg = "Full"
    M.batteryCriticalTimer = 0
end

local function update(dt)
	
	M.batteryUsage = 0
	
	if(electrics.values.lowbeam == 1) then
		M.batteryUsage = M.batteryUsage + 0.2
	end
	if(electrics.values.highbeam == 1) then
		M.batteryUsage = M.batteryUsage + 0.4
	end
	if(electrics.values.signal_R == 1) then
		M.batteryUsage = M.batteryUsage + 0.1
	end
	if(electrics.values.signal_L == 1) then
		M.batteryUsage = M.batteryUsage + 0.1
	end
	if(electrics.values.hazards == 1) then
		M.batteryUsage = M.batteryUsage + 0.2
	end
	if(MoreFeaturesMod.alarmOn) then
		M.batteryUsage = M.batteryUsage + 0.08
	end

	if(MoreFeaturesMod.configurationFile.isElectricVehicle and MoreFeaturesMod.globalConfiguration.isElectricVehicle) then
		M.batteryUsage = M.batteryUsage + (0.02 * MoreFeaturesMod.configurationFile.electricConsumptionRate) * (drivetrain.engineAV * MoreFeaturesMod.configurationFile.electricRPMMultiplier)
	end


	if(M.batteryPercentage > 100) then 
		M.batteryUsage = 0
		M.batteryPercentage = 100
	end
	if(M.batteryPercentage < 0) then 
		M.batteryUsage = 0
		M.batteryPercentage = 0 
	end
	
	if(input.rechargeBattery) then
		M.batteryPercentage = 100
		gui.message("Battery Recharged", 5, "disp.batteryCharge")
	end

	if(MoreFeaturesMod.configurationFile.isElectricVehicle and math.ceil(M.batteryPercentage) <= 30 and not M.batteryDead and not MoreFeaturesMod.EngineSystem.engineIsOff and M.is) then
		M.batteryCriticalTimer = M.batteryCriticalTimer + 1
		if(M.batteryCriticalTimer > 140) then
			MoreFeaturesMod.SoundEffects.playPitchSound("RCBatteryCriticalSound", 1, 0.2, 1) --speed / 70
			M.batteryCriticalTimer = 0
		end
	end

	if(math.ceil(M.batteryPercentage) % 10 == 0 and not M.batteryWarnTxt) then
		if(math.ceil(M.batteryPercentage) == 100) then
			M.batteryStatusMsg = " (Full)"
		elseif(math.ceil(M.batteryPercentage) == 50) then
			M.batteryStatusMsg = " (Half)"
		elseif(math.ceil(M.batteryPercentage) <= 20 and math.ceil(M.batteryPercentage) > 0) then
			M.batteryStatusMsg = " (Critical)"
		elseif(math.ceil(M.batteryPercentage) == 0) then
			M.batteryStatusMsg = " (Dead)"
		else
			M.batteryStatusMsg = ""
		end
		gui.message("Battery ".. math.ceil(M.batteryPercentage) .."%".. M.batteryStatusMsg, 5, "disp.battery")
		M.batteryWarnTxt = true
	end

	if(math.ceil(M.batteryPercentage) % 10 ~= 0) then
		M.batteryWarnTxt = false
	end

	if(M.batteryPercentage > 5) then
		M.batteryDead = false
	else
		M.batteryDead = true
	end

	if(not MoreFeaturesMod.EngineSystem.engineIsOff and not MoreFeaturesMod.configurationFile.isElectricVehicle and not MoreFeaturesMod.globalConfiguration.isElectricVehicle) then
		M.batteryChargeRate = 12 / 140
	else
		M.batteryChargeRate = 0
	end

	M.batteryPercentage = (M.batteryPercentage - (M.batteryUsage / 100)) + M.batteryChargeRate
end



M.init = init
M.update = update

return M