local M = {}
--[[
    Hello, this is the source code for the More Features Mod, you may look and modify stuff as you wish, 
    but you are not allowed to re-publish the mod or any code that you used in this without my permission.

    StinchinStein
]]--
local drivetrain = require("drivetrain")
local electrics = require("electrics")
local engine = require("engine")

M.vehicleAlreadyOn = true
M.ignitionState = 1 --Default On
M.engineIsOff = false
M.canStartEngine = true
M.stallRPM = 0
M.startingVehicle = false
M.ignitionTimerThreshhold = 5000
M.batteryPercentage = 100
M.idleThrottle = 0
M.coldStartDelay = 0

local onLoopTimer = 0
local onLoopAmount = 0
local playedChimeAlready = true

local startPressed = false
local startTimer = 0
local startTimer2 = 0
local initializeTimer = 0
local justTurnedOn = false
local justInitialized = false
local vehicleJustOn = false
local tryingToBumpStart = false


local function init()
	M.vehicleAlreadyOn = true
	M.ignitionState = 1 --Default On
	M.engineIsOff = false
	M.canStartEngine = true
	M.coldStartDelay = 0

	tryingToBumpStart = false
	startPressed = false
	startingVehicle = false
	startTimer = 0
	startTimer2 = 0
	initializeTimer = 0

	M.stallRPM = MoreFeaturesMod.configurationFile.stallRPM
end

local function startEngineDown()
    if(M.ignitionState == 1 and not startPressed and not M.startingVehicle) then
        M.ignitionTimer = 0
        M.vehicleAlreadyOn = true
        M.startingVehicle = true
        startPressed = true
        if(M.engineIsOff and MoreFeaturesMod.BatterySystem.batteryPercentage > 5) then
            MoreFeaturesMod.SoundEffects.playPitchSound("StartEngineSound", 1, 1, MoreFeaturesMod.configurationFile.startPitchModifier)
        end
    elseif(M.ignitionState == 0 and input.startEngine and not startPressed and not M.startingVehicle) then
        gui.message("vehicle is not on!", 5, "disp.startup")
    end
end

local function engineState(state)
    if(state == "on" and not M.engineIsOff) then --Started Vehicle

    elseif(state == "on" and M.engineIsOff) then --Only On
        
    elseif(state == "off") then --Off
        MoreFeaturesMod.lightsState = 0
    end
end
local function update(dt)
	
	if(input.idleThrottleUp) then
		M.idleThrottle = M.idleThrottle + 0.005
        gui.message("Throttle: ".. M.idleThrottle, 1, "disp.throttle")
	end
	if(input.idleThrottleDown) then
		M.idleThrottle = M.idleThrottle - 0.005
        gui.message("Throttle: ".. M.idleThrottle, 1, "disp.throttle")
	end
	if(M.idleThrottle < 0) then M.idleThrottle = 0 end
	if(M.idleThrottle > 1) then M.idleThrottle = 1 end
	input.throttle = input.throttle + M.idleThrottle

    M.canStartEngine = true
    local engineRPM = drivetrain.engineAV  * 9.5493

	if(M.ignitionState == 0) then M.engineIsOff = true end
    if(M.engineIsOff) then
        drivetrain.scaleEngineState(0)
        drivetrain.engineAV = 0 --Cheatsy way of doing an engine off ;D
        drivetrain.rpm = 0
        drivetrain.engineWorkPerUpdate = 0
        drivetrain.throttleFactor = 0
    else
        drivetrain.throttleFactor = 1
        vehicleJustOn = false
    end

    if(drivetrain.engineDisabled) then
        M.canStartEngine = false
        M.engineIsOff = true
    end
    if(engine.oilOverheatDamage > (v.data.engine.connectingRodDamageThreshold or 2000000)) then
        M.canStartEngine = false
    end
    
    if(MoreFeaturesMod.configurationFile.canStall and MoreFeaturesMod.globalConfiguration.canStall) then
        if(not tryingToBumpStart and (M.engineIsOff == false) and (M.startingVehicle == false) and (engineRPM < M.stallRPM and engineRPM > 0) and (initializeTimer > 20) and (drivetrain.shifterMode ~= 2) and (drivetrain.shifterMode ~= 3)) then
            M.engineIsOff = true
            M.vehicleAlreadyOn = false
        end
    end

    if(M.startingVehicle and M.engineIsOff) then
        if(electrics.values.rpm < v.data.engine.idleAV * 9.5493) then
        --    electrics.values.rpm = electrics.values.rpm + math.random(2,4) 
        end
        startTimer2 = startTimer2 + dt
        startTimer = startTimer + 1
        if(startTimer2 > 0.55 and MoreFeaturesMod.BatterySystem.batteryPercentage > 5) then
            if(startTimer < MoreFeaturesMod.configurationFile.startVehicleTimer + M.coldStartDelay or not M.canStartEngine) then
                MoreFeaturesMod.SoundEffects.playPitchSound("StartEngineSound", 1, 1, MoreFeaturesMod.configurationFile.startPitchModifier)
            elseif M.canStartEngine then 
                drivetrain.engineAV = v.data.engine.maxAV / 2
                M.engineIsOff = false
                MoreFeaturesMod.SoundEffects.playPitchSound("EngineStartedSound", 1, 1, MoreFeaturesMod.configurationFile.startPitchModifier)
                startTimer = 0
                startTimer2 = 0
                M.startingVehicle = false
                M.alarmOn = false
                M.alarmTimer = 0

                engineState("on")
            end
            startTimer2 = 0
        elseif(MoreFeaturesMod.BatterySystem.batteryPercentage > 0 and MoreFeaturesMod.BatterySystem.batteryPercentage <= 5) then
            if(startTimer2 > 0.05) then
                MoreFeaturesMod.SoundEffects.playPitchSound("StarterDeadSound", 1, 1, 1) 
                startTimer2 = 0
            end
        elseif(MoreFeaturesMod.BatterySystem.batteryPercentage == 0) then
            gui.message("Battery completely dead.", 5, "disp.battery")
        end
    end

    if(MoreFeaturesMod.configurationFile.startStopEngine and not MoreFeaturesMod.configurationFile.isElectricVehicle and MoreFeaturesMod.globalConfiguration.startStopEngine) then
    	if(input.batteryToggle and not justTurnedOn) then      
            if(M.ignitionState == 0) then
                playedChimeAlready = false
                engineState("on")
                M.ignitionState = 1
                MoreFeaturesMod.alarmOff()
                M.alarmTimer = 0
                
                gui.message("vehicle is on", 5, "disp.startup")
                MoreFeaturesMod.SoundEffects.playPitchSound("KeyInsertSound", 1, 1, 1)
                vehicleJustOn = true
            elseif(M.ignitionState == 1) then
                MoreFeaturesMod.SoundEffects.playPitchSound("KeyInsertSound", 1, 1, 1)
                if(not M.engineIsOff) then
                    MoreFeaturesMod.SoundEffects.playPitchSound("EngineStopSound", 1, 1, 1)
                end
                M.vehicleAlreadyOn = false
                vehicleJustOn = false
                M.ignitionState = 0
                gui.message("vehicle is off", 5, "disp.startup")
                engineState("off")
            end
            justTurnedOn = true
        end
    elseif(MoreFeaturesMod.configurationFile.isElectricVehicle and MoreFeaturesMod.globalConfiguration.startStopEngine) then
        if(input.batteryToggle and not justTurnedOn) then   
            if(M.ignitionState == 0) then
                engineState("on")
                M.ignitionState = 1
                M.engineIsOff = false
                
                gui.message("vehicle is on", 5, "disp.startup")
                if(MoreFeaturesMod.configurationFile.insertKeySound == "normal") then
                MoreFeaturesMod.SoundEffects.playPitchSound("KeyInsertSound", 1, 1, 1)
                elseif(MoreFeaturesMod.configurationFile.insertKeySound == "rc" and not MoreFeaturesMod.BatterySystem.batteryDead) then
                    MoreFeaturesMod.SoundEffects.playPitchSound("RCBeepSound", 1, 0.2, 1)
                end
                vehicleJustOn = true
            elseif(M.ignitionState == 1) then
                if(MoreFeaturesMod.configurationFile.insertKeySound == "normal") then
                    MoreFeaturesMod.SoundEffects.playPitchSound("KeyInsertSound", 1, 1, 1)
                end
                if(not M.engineIsOff and not MoreFeaturesMod.configurationFile.isElectricVehicle and not MoreFeaturesMod.BatterySystem.batteryDead) then
                    MoreFeaturesMod.SoundEffects.playPitchSound("EngineStopSound", 1, 1, 1)
                end
                M.engineIsOff = true
                M.vehicleAlreadyOn = false
                vehicleJustOn = false
                M.ignitionState = 0
                gui.message("vehicle is off", 5, "disp.startup")
                engineState("off")
            end
            justTurnedOn = true
        end
    end
    if(not input.batteryToggle) then
        justTurnedOn = false
    end

    if(M.ignitionState == 1 and M.engineIsOff) then
        M.ignitionTimer = M.ignitionTimer + 1
    else
        M.ignitionTimer = 0
        --onLoopAmount = 0
        --onLoopTimer = 0
    end

    if(input.startEngine) then
        --if(input.brake > 0 and (drivetrain.shifterMode ~= 2) and (drivetrain.shifterMode ~= 3) or drivetrain.shifterMode >= 2) then
            startEngineDown()
        --end
    end

    --Bumpstarting
    if(MoreFeaturesMod.configurationFile.canStall and MoreFeaturesMod.globalConfiguration.canStall) then
        if((drivetrain.avgAV > 6) and M.engineIsOff and drivetrain.gear > 0 and input.clutch < 0.1) then
            M.engineIsOff = false
            M.vehicleAlreadyOn = true
            tryingToBumpStart = true
        elseif((drivetrain.avgAV < -6) and M.engineIsOff and drivetrain.gear < 0 and input.clutch < 0.1) then
            M.engineIsOff = false
            M.vehicleAlreadyOn = true
            tryingToBumpStart = true
        else
        	if(M.engineIsOff) then
	        	input.clutch = 1
	        end
            tryingToBumpStart = false
        end
    end


    if(not input.startEngine) then
        M.startingVehicle = false
        startTimer = 0
        startTimer2 = 0
        startPressed = false
    end

    if(justInitialized) then
        M.engineIsOff = false
        justInitialized = false
    end


    if(MoreFeaturesMod.configurationFile.isElectricVehicle and MoreFeaturesMod.BatterySystem.batteryDead and MoreFeaturesMod.globalConfiguration.isElectricVehicle) then
        M.engineIsOff = true
    end

    if(M.ignitionState == 1 and not MoreFeaturesMod.BatterySystem.batteryDead and not playedChimeAlready and MoreFeaturesMod.configurationFile.chimeSound and MoreFeaturesMod.globalConfiguration.chimeSound) then
        onLoopTimer = onLoopTimer + dt

        if(onLoopTimer > 0.95 and onLoopAmount < 5) then
            MoreFeaturesMod.SoundEffects.playPitchSound("CarIgnitionSound", 1, 0.6, 1)
            onLoopAmount = onLoopAmount + 1
            onLoopTimer = 0
        elseif(onLoopAmount >= 5) then
            vehicleJustOn = false
            onLoopAmount = 0
            onLoopTimer = 0
            playedChimeAlready = true
        end

    end

    initializeTimer = initializeTimer + 1
end



M.init = init
M.update = update
M.startEngine = startEngine

return M