local M = {}
--[[
    Hello, this is the source code for the More Features Mod, you may look and modify stuff as you wish, 
    but you are not allowed to re-publish the mod or any code that you used in this without my permission.

    StinchinStein
]]--

local drivetrain = require("drivetrain")

M.wheelInfo = {}
M.wheels = {}

local function updateWheelSlip(p)
    if not p then return end
    if not v.data.nodes[p.id1] then return end
    local wheelID = v.data.nodes[p.id1].wheelID

    if wheelID then
        local wInfo = M.wheelInfo[wheelID]
        wInfo.lastSlip = math.max(p.slipVel, wInfo.lastSlip)
        -- Smoothed instant energy (E/dt)
        wInfo.slipEnergy = 0.5 * (p.slipForce * p.slipVel + wInfo.slipEnergy)
        wInfo.contactMaterialID1 = p.materialID1
        wInfo.contactMaterialID2 = p.materialID2
        wInfo.contactDepth = math.max (p.depth, wInfo.contactDepth)
        wInfo.downForceRaw = wInfo.downForceRaw - p.normalForce

        wInfo.wearAndTear = wInfo.wearAndTear + wInfo.slipEnergy / 41820

		if wInfo.wearAndTear > 100 and wInfo.showWearMsg == false then
			beamstate.deflateTire(wheelID, 1)
			wInfo.showWearMsg = true
		end
    end
end

local function init()
	M.wheelInfo = drivetrain.wheelInfo
	M.wheels = drivetrain.wheels
	
	for n,wd in pairs_safe(M.wheelInfo) do
        wobj = obj:getWheel(wd.wheelID)
        if wobj then
        	M.wheelInfo[wd.wheelID].wearAndTear = 0
        	M.wheelInfo[wd.wheelID].showWearMsg = false
        end
    end

    drivetrain.updateWheelSlip = updateWheelSlip
end

local function update()
	
end

M.init = init
M.update = update

return M