local M = {}
--[[
    Hello, this is the source code for the More Features Mod, you may look and modify stuff as you wish, 
    but you are not allowed to re-publish the mod or any code that you used in this without my permission.

    StinchinStein
]]--

local vehicleName = "Default"
M.jsonDefaultFile = nil
M.jsonGlobalConfiguration = nil
M.jsonFile = nil

local function readSettings()
    
    MoreFeaturesMod.vehicleSts.Brand = (MoreFeaturesMod.vehicleSts.Brand) or "MFMConfig"

    vehicleName = MoreFeaturesMod.vehicleSts.Brand .." ".. MoreFeaturesMod.vehicleSts.Name

    vehicleName = vehicleName:gsub("%/", "")
    local settingsDir = "lua/vehicle/MFM_VehicleSettings/"

    M.jsonDefaultFile = readJsonFile(settingsDir .."parents/defaultValues.json")
    M.jsonGlobalConfiguration = readJsonFile("lua/Global_Options.json")

    if(FS:fileExists(settingsDir.. vehicleName ..".json")) then
        M.jsonFile = readJsonFile(settingsDir.. vehicleName ..".json")
        print("Read File: ".. vehicleName)
    else
        print("No JSON File Found; Configuration File Name Should Be \"".. vehicleName .. ".json\"")
        M.jsonFile = M.jsonDefaultFile
    end


    if(FS:fileExists(settingsDir.. vehicleName ..".json")) then
        if(FS:fileExists(settingsDir.. M.jsonFile.parent)) then
            M.jsonDefaultFile = readJsonFile(settingsDir ..M.jsonFile.parent)
        end

        --Yes.. Inefficient I know. You know a better way to do it?
        if(M.jsonFile.vehicleName ~= nil) then M.jsonDefaultFile.vehicleName = M.jsonFile.vehicleName end
        if(M.jsonFile.stallRPM ~= nil) then M.jsonDefaultFile.stallRPM = M.jsonFile.stallRPM end
        if(M.jsonFile.startVehicleTimer ~= nil) then M.jsonDefaultFile.startVehicleTimer = M.jsonFile.startVehicleTimer end
        if(M.jsonFile.canStall ~= nil) then M.jsonDefaultFile.canStall = M.jsonFile.canStall end
        if(M.jsonFile.newClutchSystem ~= nil) then M.jsonDefaultFile.newClutchSystem = M.jsonFile.newClutchSystem end
        if(M.jsonFile.blinkerSounds ~= nil) then M.jsonDefaultFile.blinkerSounds = M.jsonFile.blinkerSounds end
        if(M.jsonFile.parkingBrakeSounds ~= nil) then M.jsonDefaultFile.parkingBrakeSounds = M.jsonFile.parkingBrakeSounds end
        if(M.jsonFile.reverseSoundType ~= nil) then M.jsonDefaultFile.reverseSoundType = M.jsonFile.reverseSoundType end
        if(M.jsonFile.brakeSquealSounds ~= nil) then M.jsonDefaultFile.brakeSquealSounds = M.jsonFile.brakeSquealSounds end
        if(M.jsonFile.compatibleWithMod ~= nil) then M.jsonDefaultFile.compatibleWithMod = M.jsonFile.compatibleWithMod end
        if(M.jsonFile.gaugeStartupType ~= nil) then M.jsonDefaultFile.gaugeStartupType = M.jsonFile.gaugeStartupType end
        if(M.jsonFile.startPitchModifier ~= nil) then M.jsonDefaultFile.startPitchModifier = M.jsonFile.startPitchModifier end
        if(M.jsonFile.hazardCrash ~= nil) then M.jsonDefaultFile.hazardCrash = M.jsonFile.hazardCrash end
        if(M.jsonFile.alarmEnabled ~= nil) then M.jsonDefaultFile.alarmEnabled = M.jsonFile.alarmEnabled end
        if(M.jsonFile.batterySimulation ~= nil) then M.jsonDefaultFile.batterySimulation = M.jsonFile.batterySimulation end
        if(M.jsonFile.tireWearSimulation ~= nil) then M.jsonDefaultFile.tireWearSimulation = M.jsonFile.tireWearSimulation end
        if(M.jsonFile.startStopEngine ~= nil) then M.jsonDefaultFile.startStopEngine = M.jsonFile.startStopEngine end
        if(M.jsonFile.enableHorn ~= nil) then M.jsonDefaultFile.enableHorn = M.jsonFile.enableHorn end
        if(M.jsonFile.isElectricVehicle ~= nil) then M.jsonDefaultFile.isElectricVehicle = M.jsonFile.isElectricVehicle end
        if(M.jsonFile.electricConsumptionRate ~= nil) then M.jsonDefaultFile.electricConsumptionRate = M.jsonFile.electricConsumptionRate end
        if(M.jsonFile.chimeSound ~= nil) then M.jsonDefaultFile.chimeSound = M.jsonFile.chimeSound end
        if(M.jsonFile.insertKeySound ~= nil) then M.jsonDefaultFile.insertKeySound = M.jsonFile.insertKeySound end
        if(M.jsonFile.electricRPMMultiplier ~= nil) then M.jsonDefaultFile.electricRPMMultiplier = M.jsonFile.electricRPMMultiplier end
        if(M.jsonFile.shiftSounds ~= nil) then M.jsonDefaultFile.shiftSounds = M.jsonFile.shiftSounds end
        if(M.jsonFile.lockShifterMode ~= nil) then M.jsonDefaultFile.lockShifterMode = M.jsonFile.lockShifterMode end
        if(M.jsonFile.crashAlertType ~= nil) then M.jsonDefaultFile.crashAlertType = M.jsonFile.crashAlertType end
        if(M.jsonFile.airbrakeSound ~= nil) then M.jsonDefaultFile.airbrakeSound = M.jsonFile.airbrakeSound end
        if(M.jsonFile.blinkerSoundType ~= nil) then M.jsonDefaultFile.blinkerSoundType = M.jsonFile.blinkerSoundType end
        if(M.jsonFile.chokeEnabled ~= nil) then M.jsonDefaultFile.chokeEnabled = M.jsonFile.chokeEnabled end
        if(M.jsonFile.chokeInc ~= nil) then M.jsonDefaultFile.chokeInc = M.jsonFile.chokeInc end
    
    end
end

local function init()
    readSettings()

end
local function update()

end


M.readSettings = readSettings
M.init = init
M.update = update
return M